# -*- coding: utf-8 -*-

class CCException(Exception):
    '''
    '''
    def __init__(self, message, exception=None):
        '''
        '''
        self._exception = exception
        self._message = message
    
    def __str__(self):
        '''
        '''
        if self._exception is not None:
            return '[%s] %s' % (self._exception, self._message)
        else:
            return '%s' % self._message


# host

class HostError(CCException):
    '''
    '''
    pass


class HypervisorError(HostError):
    '''
    '''
    pass


class VMError(HostError):
    '''
    '''
    pass


# storage

class StorageError(CCException):
    '''
    '''
    pass


class StoragePoolError(StorageError):
    '''
    '''
    pass


class StorageVolumeError(StorageError):
    '''
    '''
    pass


# lvm errors

class LVMError(CCException):
    '''
    '''
    pass

# drbd errors

class DRBDPoolError(CCException):
    '''
    '''
    pass


class DRBDError(CCException):
    '''
    '''
    pass

# job errors

class JobManagerError(CCException):
    '''
    '''
    pass


class JobError(CCException):
    '''
    '''
    pass


class XferJobError(JobError):
    '''
    '''
    pass
    
class ReceiveFileJobError(XferJobError):
    '''
    '''
    pass

class SendFileJobError(XferJobError):
    '''
    '''
    pass
    
class DrbdCopyJobError(JobError):
    '''
    '''
    pass

class TCPTunnelJobError(JobError):
    '''
    '''
    pass
